/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube    ---   Limitations and specifcities:    * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Preset import and export from/to file is a server only feature.   * Device set focus is a GUI only feature.   * The following channels are not implemented (status 501 is returned): ATV and DATV demodulators, Channel Analyzer NG, LoRa demodulator   * The device settings and report structures contains only the sub-structure corresponding to the device type. The DeviceSettings and DeviceReport structures documented here shows all of them but only one will be or should be present at a time   * The channel settings and report structures contains only the sub-structure corresponding to the channel type. The ChannelSettings and ChannelReport structures documented here shows all of them but only one will be or should be present at a time    --- 
 *
 * OpenAPI spec version: 4.13.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

/*
 * SWGFileInputReport.h
 *
 * FileInput
 */

#ifndef SWGFileInputReport_H_
#define SWGFileInputReport_H_

#include <QJsonObject>


#include <QString>

#include "SWGObject.h"
#include "export.h"

namespace SWGSDRangel {

class SWG_API SWGFileInputReport: public SWGObject {
public:
    SWGFileInputReport();
    SWGFileInputReport(QString* json);
    virtual ~SWGFileInputReport();
    void init();
    void cleanup();

    virtual QString asJson () override;
    virtual QJsonObject* asJsonObject() override;
    virtual void fromJsonObject(QJsonObject &json) override;
    virtual SWGFileInputReport* fromJson(QString &jsonString) override;

    QString* getFileName();
    void setFileName(QString* file_name);

    qint32 getSampleRate();
    void setSampleRate(qint32 sample_rate);

    qint32 getSampleSize();
    void setSampleSize(qint32 sample_size);

    QString* getAbsoluteTime();
    void setAbsoluteTime(QString* absolute_time);

    QString* getElapsedTime();
    void setElapsedTime(QString* elapsed_time);

    QString* getDurationTime();
    void setDurationTime(QString* duration_time);


    virtual bool isSet() override;

private:
    QString* file_name;
    bool m_file_name_isSet;

    qint32 sample_rate;
    bool m_sample_rate_isSet;

    qint32 sample_size;
    bool m_sample_size_isSet;

    QString* absolute_time;
    bool m_absolute_time_isSet;

    QString* elapsed_time;
    bool m_elapsed_time_isSet;

    QString* duration_time;
    bool m_duration_time_isSet;

};

}

#endif /* SWGFileInputReport_H_ */
